Subject: bug#18648: rm -f with no file operands fails on old BSD systems

From: Richard Hansen <[email-masked]>
Date: Mon, 06 Oct 2014 22:51:45 -0400

Hi all,

A friend reported this to me:

> $ ./configure
> ...
> usage: rm [-f|-i] [-dPRrvW] file ...
> Oops!
> 
> Your 'rm' program seems unable to run without file operands specified
> on the command line, even when the '-f' option is present.  This is contrary
> to the behaviour of most rm programs out there, and not conforming with
> the upcoming POSIX standard: <http://austingroupbugs.net/view.php?id=542>
> 
> Please tell [email-masked] about your system, including the value
> of your $PATH and any error possibly output before this message.  This
> can help us improve future automake versions.
> 
> Aborting the configuration process, to ensure you take notice of the issue.
> 
> You can download and install GNU coreutils to get an 'rm' implementation
> that behaves properly: <http://www.gnu.org/software/coreutils/>.
> 
> If you want to complete the configuration process using your problematic
> 'rm' anyway, export the environment variable ACCEPT_INFERIOR_RM_PROGRAM
> to "yes", and re-run configure.
> 
> configure: error: Your 'rm' program is bad, sorry.
> $ uname -a
> NetBSD example.com 4.0_STABLE NetBSD 4.0_STABLE (GENERIC) #4: Wed Mar 14 13:59:06 EDT 2012  [email-masked]:/usr/obj/sparc/sys/arch/sparc/compile/GENERIC sparc
> $ /bin/rm -f
> usage: rm [-f|-i] [-dPRrvW] file ...
> $ echo $?
> 1

Digging around in various CVS/Subversion repositories, it looks like
there are many old (but perhaps not yet museum-worthy) *BSD versions
that behave this way:

  * NetBSD 4.x and older (5.0 released April 2009).  see: [1] [2]
  * FreeBSD 3.1.x and older (3.2 released May 1999).  see: [3] [4]
  * OpenBSD 2.x and older (3.0 released Dec 2001).  see [5]

Given this, I wonder if POSIX bug #542 [6] should be revisited. Perhaps
that bug should change the wording to "unspecified" for Issue 7 TC2, and
we can file a new bug report to adopt the wording currently in #542 for
Issue 8.  Thoughts?

Thanks,
Richard

[1] http://cvsweb.netbsd.org/bsdweb.cgi/src/bin/rm/rm.c#rev1.47
[2] http://gnats.netbsd.org/cgi-bin/query-pr-single.pl?number=38754
[3] https://svnweb.freebsd.org/base?view=revision&revision=44282
[4] https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=10252
[5] http://cvsweb.openbsd.org/cgi-bin/cvsweb/src/bin/rm/rm.c#rev1.10
[6] http://austingroupbugs.net/view.php?id=542